package eu.eudat.data.entities;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Type;

import javax.persistence.*;
import java.util.UUID;


@Entity
@Table(name = "\"DatasetExternalDataset\"")
public class DatasetExternalDataset {

    @Id
    @GeneratedValue
    @GenericGenerator(name = "uuid2", strategy = "uuid2")
    @Column(name = "\"Id\"", updatable = false, nullable = false, columnDefinition = "BINARY(16)")
    private UUID id;


    @Type(type = "org.hibernate.type.PostgresUUIDType") //DEPWARN dependency to Hibernate and PostgreSQL
    @Column(name = "\"Dataset\"", nullable = false)
    private UUID dataset;

    @Type(type = "org.hibernate.type.PostgresUUIDType") //DEPWARN dependency to Hibernate and PostgreSQL
    @Column(name = "\"ExternalDataset\"", nullable = false)
    private UUID externalDataset;

    @Column(name = "\"Role\"")
    private Integer role;

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    public UUID getDataset() {
        return dataset;
    }

    public void setDataset(UUID dataset) {
        this.dataset = dataset;
    }

    public UUID getExternalDataset() {
        return externalDataset;
    }

    public void setExternalDataset(UUID externalDataset) {
        this.externalDataset = externalDataset;
    }

    public Integer getRole() {
        return role;
    }

    public void setRole(Integer role) {
        this.role = role;
    }
}
