package eu.eudat.builders.model.models;

import eu.eudat.builders.Builder;
import eu.eudat.models.dmp.Researcher;

/**
 * Created by ikalyvas on 3/6/2018.
 */
public class ResearcherBuilder extends Builder<Researcher> {
    private String label;
    private String name;
    private String id;
    private int status;

    public String getLabel() {
        return label;
    }

    public ResearcherBuilder label(String label) {
        this.label = label;
        return this;
    }

    public String getName() {
        return name;
    }

    public ResearcherBuilder name(String name) {
        this.name = name;
        return this;
    }

    public String getId() {
        return id;
    }

    public ResearcherBuilder id(String id) {
        this.id = id;
        return this;
    }

    public int getStatus() {
        return status;
    }

    public ResearcherBuilder status(int status) {
        this.status = status;
        return this;
    }

    @Override
    public Researcher build() {
        Researcher researcher = new Researcher();
        researcher.setId(id);
        researcher.setLabel(label);
        researcher.setName(name);
        researcher.setStatus(status);
        return researcher;
    }
}
