package eu.eudat.controllers;

import eu.eudat.dynamicproject.DynamicProjectConfiguration;
import eu.eudat.dynamicproject.entities.Language;
import eu.eudat.models.helpers.responses.ResponseItem;
import eu.eudat.models.security.Principal;
import eu.eudat.types.ApiMessageCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * Created by ikalyvas on 3/28/2018.
 */
@RestController
@CrossOrigin
@RequestMapping(value = {"/api/common"})
public class CommonController {

    private DynamicProjectConfiguration dynamicProjectConfiguration;

    @Autowired
    public CommonController(DynamicProjectConfiguration dynamicProjectConfiguration) {
        this.dynamicProjectConfiguration = dynamicProjectConfiguration;
    }

    @RequestMapping(method = RequestMethod.GET, value = {"/language"}, produces = "application/json")
    public @ResponseBody
    ResponseEntity<ResponseItem<List<Language>>> getPaged(Principal principal) {
        try {
            List<Language> language = this.dynamicProjectConfiguration.getConfiguration().getMainExternalField().getLanguage();
            return ResponseEntity.status(HttpStatus.OK).body(new ResponseItem<List<Language>>().status(ApiMessageCode.NO_MESSAGE).payload(language));
        } catch (Exception ex) {
            ex.printStackTrace();
            return ResponseEntity.status(HttpStatus.BAD_REQUEST).body(new ResponseItem<List<Language>>().status(ApiMessageCode.DEFAULT_ERROR_MESSAGE).message(ex.getMessage()));
        }
    }
}
