package eu.eudat.controllers.interceptors;

import eu.eudat.services.helpers.LoggerService;
import eu.eudat.types.WarningLevel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;

/**
 * Created by ikalyvas on 3/1/2018.
 */
@Component
public class RequestInterceptor extends HandlerInterceptorAdapter {

    private LoggerService loggerService;

    @Autowired
    public RequestInterceptor(LoggerService loggerService) {
        this.loggerService = loggerService;
    }

    @Override
    public boolean preHandle(HttpServletRequest request,
                             HttpServletResponse response, Object handler) throws Exception {
        String reqUri = request.getRequestURI();
        this.loggerService.log("Call to " + reqUri + " method: " + request.getMethod() + " at: " + new Date(), WarningLevel.INFO);
        return super.preHandle(request, response, handler);
    }
}
