package eu.eudat.managers;

import eu.eudat.builders.entity.DatasetProfileBuilder;
import eu.eudat.models.entities.xmlmodels.datasetprofiledefinition.ViewStyleModel;
import eu.eudat.models.admin.composite.DatasetProfile;
import eu.eudat.services.ApiContext;
import eu.eudat.utilities.builders.ModelBuilder;
import eu.eudat.utilities.builders.XmlBuilder;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import java.util.Date;

public class AdminManager {

    public static eu.eudat.data.entities.DatasetProfile generateViewStyleDefinition(DatasetProfile profile, ApiContext apiContext) {
        ViewStyleModel viewStyleModel = new ViewStyleModel();
        viewStyleModel.setSections(new ModelBuilder().toViewStyleDefinition(profile.getSections(), eu.eudat.models.entities.xmlmodels.datasetprofiledefinition.Section.class));
        viewStyleModel.setPages(new ModelBuilder().toViewStyleDefinition(profile.getPages(), eu.eudat.models.entities.xmlmodels.datasetprofiledefinition.Page.class));
        Document viewStyleDoc = XmlBuilder.getDocument();
        Element elementViewStyle = viewStyleModel.toXml(viewStyleDoc);
        viewStyleDoc.appendChild(elementViewStyle);
        String xml = XmlBuilder.generateXml(viewStyleDoc);

        eu.eudat.data.entities.DatasetProfile datasetProfile = apiContext.getOperationsContext().getBuilderFactory().getBuilder(DatasetProfileBuilder.class).definition(xml).label(profile.getLabel())
                .status((short) 1).created(new Date())
                .build();

        return datasetProfile;
    }

    public static eu.eudat.models.admin.composite.DatasetProfile generateDatasetProfileModel(eu.eudat.data.entities.DatasetProfile profile) {
        Document viewStyleDoc = XmlBuilder.fromXml(profile.getDefinition());
        Element root = viewStyleDoc.getDocumentElement();
        eu.eudat.models.entities.xmlmodels.datasetprofiledefinition.ViewStyleModel viewstyle = new eu.eudat.models.entities.xmlmodels.datasetprofiledefinition.ViewStyleModel().fromXml(root);

        eu.eudat.models.admin.composite.DatasetProfile datasetprofile = new eu.eudat.models.admin.composite.DatasetProfile();
        datasetprofile.buildProfile(viewstyle);
        return datasetprofile;
    }
}
