package eu.eudat.models.admin.composite;

import eu.eudat.models.admin.components.datasetprofile.Page;
import eu.eudat.models.admin.components.datasetprofile.Section;
import eu.eudat.utilities.builders.ModelBuilder;

import java.util.List;

public class DatasetProfile {
    private String label;
    private List<Section> sections;
    private List<Page> pages;

    public List<Section> getSections() {
        return sections;
    }

    public void setSections(List<Section> sections) {
        this.sections = sections;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public List<Page> getPages() {
        return pages;
    }

    public void setPages(List<Page> pages) {
        this.pages = pages;
    }

    public void buildProfile(eu.eudat.models.entities.xmlmodels.datasetprofiledefinition.ViewStyleModel viewStyle) {
        this.sections = new ModelBuilder().fromViewStyleDefinition(viewStyle.getSections(), Section.class);
        this.pages = new ModelBuilder().fromViewStyleDefinition(viewStyle.getPages(), Page.class);
    }
}
