import { Component, ViewEncapsulation, OnInit, OnDestroy, Input } from "@angular/core";
import { FormGroup, FormArray } from "@angular/forms";
import { DynamicFieldDependency } from "../../../models/data-managemnt-plans/DynamicFieldDependency";

@Component({
    selector: 'app-dynamic-fields-project',
    templateUrl: 'dynamic-fields-project.component.html',
    styleUrls: ['./dynamic-fields-project.component.scss'],
    providers: [],
    encapsulation: ViewEncapsulation.None
})
export class DynamicFieldsProjectComponent implements OnInit {

    @Input()
    formGroup: FormGroup;

    ngOnInit(): void {
        console.log(this.formGroup)
    }

    findDependencies(id: number) {
        let formGroupDependencies: Array<FormGroup> = new Array<FormGroup>();
        let dynamicFieldDependency: DynamicFieldDependency[] = (<FormArray>this.formGroup.get("dynamicFields")).at(id).get("dependencies").value
        if (dynamicFieldDependency.length > 0) {
            dynamicFieldDependency.forEach(item => {
                let length = (<FormArray>this.formGroup.get("dynamicFields")).length;
                for (let i = 0; i < length; i++) {
                    let formGroup = (<FormArray>this.formGroup.get("dynamicFields")).at(i);
                    if (formGroup.get("id").value === item.id) formGroupDependencies.push(<FormGroup>formGroup);
                }
            })
        }
        return formGroupDependencies;
    }
}  