import { BaseCriteriaComponent } from './components/criteria/base/base-criteria.component';
import { FigurecardComponent } from './components/figurecard/figurecard.component';
import { AutocompleteComponent } from './components/autocomplete/autocomplete.component';
import { CommonModule } from '@angular/common';
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { NavigationComponent } from './components/navigation/navigation.component';
import { SnackBarNotificationComponent } from './components/notificaiton/snack-bar-notification.component';
import { MaterialModule } from './material/material.module';
import { TranslateModule } from '@ngx-translate/core';
import { ProjectCriteriaComponent } from './components/criteria/projects/projects-criteria.component';
import { DatasetCriteriaComponent } from './components/criteria/datasets/datasets-criteria.component';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { DataManagementPlanCriteriaComponent } from './components/criteria/data-management-plan/dmp-criteria.component';
import { AutocompleteChipComponent } from '@app/shared/components/autocompleteChips/autocompleteChips.component';
import { FileUploaderComponent } from '@app/shared/components/file-uploader/file-uploader.component';
import { UrlListingComponent } from '@app/shared/components/url-listing/url-listing.component';
import { NgForLimitPipe } from '@app/shared/pipes/ngforlimit/NgForLimit.pipe';
import { DataManagementPlanProfileCriteriaComponent } from './components/criteria/datamanagementplanprofile/dmp-profile-criteria.component';
import { AutoCompleteComponent } from './components/auto-complete/auto-complete.component';

@NgModule({
	imports: [
		CommonModule,
		RouterModule,
		MaterialModule,
		TranslateModule,
		FormsModule,
		ReactiveFormsModule
	],

	declarations: [
		NavigationComponent,
		SnackBarNotificationComponent,
		ProjectCriteriaComponent,
		DatasetCriteriaComponent,
		DataManagementPlanCriteriaComponent,
		DataManagementPlanProfileCriteriaComponent,
		AutocompleteComponent,
		FigurecardComponent,
		BaseCriteriaComponent,
		FileUploaderComponent,
		AutocompleteChipComponent,
		UrlListingComponent,
		NgForLimitPipe,
		AutoCompleteComponent
	],

	exports: [
		MaterialModule,
		NavigationComponent,
		SnackBarNotificationComponent,
		ProjectCriteriaComponent,
		DatasetCriteriaComponent,
		DataManagementPlanProfileCriteriaComponent,
		DataManagementPlanCriteriaComponent,
		AutocompleteComponent,
		FigurecardComponent,
		BaseCriteriaComponent,
		FileUploaderComponent,
		AutocompleteChipComponent,
		UrlListingComponent,
		NgForLimitPipe,
		AutoCompleteComponent
	],
	entryComponents: [
	]
})

export class SharedModule { }
